package net.mcreator.realmforge.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.10.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelscavenger<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("realmforge", "modelscavenger"), "main");
	public final ModelPart head;
	public final ModelPart lower_tail;
	public final ModelPart lower_body;
	public final ModelPart upper_tail;
	public final ModelPart body;
	public final ModelPart left_arm;
	public final ModelPart right_arm;
	public final ModelPart front_legs;
	public final ModelPart back_legs;

	public Modelscavenger(ModelPart root) {
		this.head = root.getChild("head");
		this.lower_tail = root.getChild("lower_tail");
		this.lower_body = root.getChild("lower_body");
		this.upper_tail = root.getChild("upper_tail");
		this.body = root.getChild("body");
		this.left_arm = root.getChild("left_arm");
		this.right_arm = root.getChild("right_arm");
		this.front_legs = root.getChild("front_legs");
		this.back_legs = root.getChild("back_legs");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition head = partdefinition.addOrReplaceChild("head",
				CubeListBuilder.create().texOffs(80, 0).addBox(-5.0F, -7.0F, -10.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(0, 38).addBox(0.0F, -12.0F, -10.0F, 0.0F, 5.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offset(1.0F, 12.0F, 9.0F));
		PartDefinition lower_tail = partdefinition.addOrReplaceChild("lower_tail",
				CubeListBuilder.create().texOffs(40, 44).addBox(-3.0F, -3.0F, 0.0F, 6.0F, 6.0F, 28.0F, new CubeDeformation(0.0F)).texOffs(0, 24).addBox(1.0F, -7.0F, 27.0F, 0.0F, 12.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offset(1.0F, 30.0F, 89.0F));
		PartDefinition cube_r1 = lower_tail.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(0, 0).addBox(1.0F, -12.0F, -1.0F, 0.0F, 12.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.0F, -1.0F, 28.0F, 0.0F, 0.0F, 1.5708F));
		PartDefinition lower_body = partdefinition.addOrReplaceChild("lower_body", CubeListBuilder.create().texOffs(0, 36).addBox(-2.0F, 29.0F, 8.0F, 6.0F, 8.0F, 28.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -2.0F, 25.0F));
		PartDefinition upper_tail = partdefinition.addOrReplaceChild("upper_tail", CubeListBuilder.create().texOffs(0, 0).addBox(-3.0F, -2.0F, -1.0F, 6.0F, 8.0F, 28.0F, new CubeDeformation(0.0F)), PartPose.offset(1.0F, 29.0F, 62.0F));
		PartDefinition body = partdefinition.addOrReplaceChild("body", CubeListBuilder.create(), PartPose.offset(0.0F, 28.0F, 34.0F));
		PartDefinition cube_r2 = body.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(0, 50).addBox(1.0F, 9.0F, -1.0F, 0.0F, 5.0F, 28.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -30.0F, -9.0F, -0.7854F, 0.0F, 0.0F));
		PartDefinition cube_r3 = body.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(40, 8).addBox(-5.0F, -8.0F, -1.0F, 6.0F, 8.0F, 28.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(3.0F, -15.0F, -24.0F, -0.7854F, 0.0F, 0.0F));
		PartDefinition left_arm = partdefinition.addOrReplaceChild("left_arm", CubeListBuilder.create().texOffs(24, 83).addBox(0.0F, 16.0F, -19.0F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)), PartPose.offset(4.0F, 15.0F, 18.0F));
		PartDefinition cube_r4 = left_arm.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(108, 20).addBox(0.0F, -5.0F, -3.0F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -1.0F, 1.0F, -0.7854F, 0.0F, 0.0F));
		PartDefinition right_arm = partdefinition.addOrReplaceChild("right_arm", CubeListBuilder.create().texOffs(0, 83).addBox(-6.0F, 16.0F, -19.0F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)), PartPose.offset(-2.0F, 15.0F, 18.0F));
		PartDefinition cube_r5 = right_arm.addOrReplaceChild("cube_r5", CubeListBuilder.create().texOffs(98, 78).addBox(-6.0F, -14.0F, 15.0F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -7.0F, -18.0F, -0.7854F, 0.0F, 0.0F));
		PartDefinition front_legs = partdefinition.addOrReplaceChild("front_legs", CubeListBuilder.create(), PartPose.offsetAndRotation(1.0F, 33.0F, 42.0F, -0.6109F, 3.1416F, 0.0F));
		PartDefinition cube_r6 = front_legs.addOrReplaceChild("cube_r6",
				CubeListBuilder.create().texOffs(66, 114).addBox(-6.0F, -4.0F, -1.0F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(42, 114).addBox(-18.0F, -5.3827F, -2.9239F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(9.0F, 2.055F, 2.0267F, 1.0036F, 0.0F, 0.0F));
		PartDefinition back_legs = partdefinition.addOrReplaceChild("back_legs", CubeListBuilder.create(), PartPose.offsetAndRotation(1.0F, 34.0F, 58.0F, -0.6109F, 3.1416F, 0.0F));
		PartDefinition cube_r7 = back_legs.addOrReplaceChild("cube_r7", CubeListBuilder.create().texOffs(74, 78).addBox(-6.0F, -2.0F, -6.0F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(9.0F, -1.9414F, 3.5595F, 0.1745F, 0.0F, 0.0F));
		PartDefinition cube_r8 = back_legs.addOrReplaceChild("cube_r8", CubeListBuilder.create().texOffs(50, 78).addBox(0.0F, -1.5774F, -5.9063F, 6.0F, 30.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-9.0F, -1.9414F, 2.5595F, 0.1745F, 0.0F, 0.0F));
		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void setupAnim(Entity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green, float blue, float alpha) {
		head.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		lower_tail.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		lower_body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		upper_tail.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		left_arm.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		right_arm.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		front_legs.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		back_legs.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}
}
